<template>
	<view class="uv-navbar">
		<view
			class="uv-navbar__placeholder"
			v-if="fixed && placeholder"
			:style="{
				height: $uv.addUnit($uv.getPx(height) + $uv.sys().statusBarHeight,'px'),
			}"
		></view>
		<view :class="[fixed && 'uv-navbar--fixed']">
			<image class="uv-navbar--bgimg" :src="bgColor" :mode="imgMode" v-if="isImg" :style="[bgImgStyle]"></image>
			<uv-status-bar
				v-if="safeAreaInsetTop"
				:bgColor="getStatusbgColor"
			></uv-status-bar>
			<view
				class="uv-navbar__content"
				:class="[border && 'uv-border-bottom']"
				:style="[{
					height: $uv.addUnit(height)
				},getBgColor]"
			>
				<view
					class="uv-navbar__content__left"
					hover-class="uv-navbar__content__left--hover"
					hover-start-time="150"
					@tap="leftClick"
				>
					<slot name="left">
						<uv-icon
							v-if="leftIcon"
							:name="leftIcon"
							:size="leftIconSize"
							:color="leftIconColor"
						></uv-icon>
						<text
							v-if="leftText"
							:style="{
								color: leftIconColor
							}"
							class="uv-navbar__content__left__text"
						>{{ leftText }}</text>
					</slot>
				</view>
				<slot name="center">
					<text
						class="uv-line-1 uv-navbar__content__title"
						:style="[{
							width: $uv.addUnit(titleWidth),
							flex: '0 1 auto'
						}, $uv.addStyle(titleStyle)]"
					>{{ title }}</text>
				</slot>
				<view
					class="uv-navbar__content__right"
					@tap="rightClick"
				>
					<slot name="right">
						<uv-icon
							v-if="rightIcon"
							:name="rightIcon"
							size="20"
						></uv-icon>
						<text
							v-if="rightText"
							class="uv-navbar__content__right__text"
						>{{ rightText }}</text>
					</slot>
				</view>
			</view>
		</view>
	</view>
</template>

<script>
	import mpMixin from '@/uni_modules/uv-ui-tools/libs/mixin/mpMixin.js'
	import mixin from '@/uni_modules/uv-ui-tools/libs/mixin/mixin.js'
	import props from './props.js';
	/**
	 * Navbar 自定義導航欄
	 * @description 此組件壹般用於在特殊情況下，需要自定義導航欄的時候用到，壹般建議使用uni-app帶的導航欄。
	 * @tutorial https://www.uvui.cn/components/navbar.html
	 * @property {Boolean}			safeAreaInsetTop	是否開啟頂部安全區適配  （默認 true ）
	 * @property {Boolean}			placeholder			固定在頂部時，是否生成壹個等高元素，以防止塌陷 （默認 false ）
	 * @property {Boolean}			fixed				導航欄是否固定在頂部 （默認 false ）
	 * @property {Boolean}			border				導航欄底部是否顯示下邊框 （默認 false ）
	 * @property {String}			leftIcon			左邊返回圖標的名稱，只能為uvui自帶的圖標 （默認 'arrow-left' ）
	 * @property {String}			leftText			左邊的提示文字
	 * @property {String}			rightText			右邊的提示文字
	 * @property {String}			rightIcon			右邊返回圖標的名稱，只能為uvui自帶的圖標
	 * @property {String}			title				導航欄標題，如設置為空字符，將會隱藏標題占位區域
	 * @property {String}			bgColor				導航欄背景設置 （默認 '#ffffff' ）
	 * @property {String | Number}	titleWidth			導航欄標題的最大寬度，內容超出會以省略號隱藏 （默認 '400rpx' ）
	 * @property {String | Number}	height				導航欄高度(不包括狀態欄高度在內，內部自動加上)（默認 '44px' ）
	 * @property {String | Number}	leftIconSize		左側返回圖標的大小（默認 20px ）
	 * @property {String | Number}	leftIconColor		左側返回圖標的顏色（默認 #303133 ）
	 * @property {Boolean}	        autoBack			點擊左側區域(返回圖標)，是否自動返回上壹頁（默認 false ）
	 * @property {Object | String}	titleStyle			標題的樣式，對象或字符串
	 * @event {Function} leftClick		點擊左側區域
	 * @event {Function} rightClick		點擊右側區域
	 * @example <uv-navbar title="劍未配妥，出門已是江湖" left-text="返回" right-text="幫助" @click-left="onClickBack" @click-right="onClickRight"></uv-navbar>
	 */
	export default {
		name: 'uv-navbar',
		mixins: [mpMixin, mixin, props],
		data() {
			return {

			}
		},
		computed: {
			getBgColor(){
				const style = {};
				if(this.bgColor){
					if (this.bgColor.indexOf("gradient") > -1) {// 漸變色
						style.backgroundImage = this.bgColor;
					}else if(this.isImg){
						style.background = 'transparent';
					}else {
						style.background = this.bgColor;
					}
				}
				return style;
			},
			getStatusbgColor() {
				if(this.bgColor){
					if(this.isImg){
						return 'transparent';
					}else {
						return this.bgColor;
					}
				}
			},
			// 判斷傳入的bgColor屬性，是否圖片路徑，只要帶有"/"均認為是圖片形式
			isImg() {
				const isBase64 = this.bgColor.indexOf('data:') > -1 && this.bgColor.indexOf('base64') > -1;
				return this.bgColor.indexOf('/') !== -1 || isBase64;
			},
			bgImgStyle() {
				const style = {};
				if(this.safeAreaInsetTop) {
					style.height = this.$uv.addUnit(this.$uv.sys().statusBarHeight + 44, 'px');
				} else {
					style.height = '44px';
				}
				return style;
			}
		},
		methods: {
			// 點擊左側區域
			leftClick() {
				// 如果配置了autoBack，自動返回上壹頁
				this.$emit('leftClick')
				if(this.autoBack) {
					uni.navigateBack()
				}
			},
			// 點擊右側區域
			rightClick() {
				this.$emit('rightClick')
			}
		}
	}
</script>

<style lang="scss" scoped>
 	$show-border: 1;
	$show-border-bottom: 1;
	$show-lines: 1;
	@import '@/uni_modules/uv-ui-tools/libs/css/variable.scss';
	@import '@/uni_modules/uv-ui-tools/libs/css/components.scss';
	@import '@/uni_modules/uv-ui-tools/libs/css/color.scss';
	.uv-navbar {
		position: relative;
		&--fixed {
			position: fixed;
			left: 0;
			right: 0;
			top: 0;
			z-index: 11;
		}
		
		&--bgimg {
			position: absolute;
			left: 0;
			right: 0;
			bottom: 0;
			top: 0;
			/* #ifndef APP-NVUE */
			width: 100%;
			height: 100%;
			/* #endif */
			/* #ifdef APP-NVUE */
			width: 750rpx;
			/* #endif */
		}

		&__content {
			@include flex(row);
			align-items: center;
			height: 44px;
			background-color: #9acafc;
			position: relative;
			justify-content: center;

			&__left,
			&__right {
				padding: 0 13px;
				position: absolute;
				top: 0;
				bottom: 0;
				@include flex(row);
				align-items: center;
			}

			&__left {
				left: 20rpx;
				
				&--hover {
					opacity: 0.7;
				}

				&__text {
					font-size: 15px;
					margin-left: 3px;
				}
			}

			&__title {
				text-align: center;
				font-size: 16px;
				color: $uv-main-color;
			}

			&__right {
				right: 0;

				&__text {
					font-size: 15px;
					margin-left: 3px;
				}
			}
		}
	}
</style>
